viTextTicker = {};

function viTextTicker:getPos()
	local height = 0.0135;
	local optiSize = g_currentMission.hl.optiHeightSize(height, "Ä", 0.015)-0.001;	
	local x1, y1, w1, h1 = g_currentMission.hl.getOverlay(g_currentMission.hud.gameInfoDisplay.backgroundOverlay.overlay);		
	return {1, 1-w1, y1, w1, height, optiSize, getTextHeight(optiSize, "Ä")};		
end;

function viTextTicker:updatePos()
	if VehicleInspector.global.textTicker.isOn then
		if g_currentMission.hl.textTicker.mods["VehicleInspector"] ~= nil then		
			if g_currentMission.hl.textTicker.mods["MultiOverlayV4"] ~= nil then VehicleInspector.global.textTicker.isOn = false;viTextTicker:setOnOff();return;end;
			local x1, y1, w1, h1 = g_currentMission.hl.getOverlay(g_currentMission.hud.gameInfoDisplay.backgroundOverlay.overlay);
			local textTicker = g_currentMission.hl.textTicker.mods["VehicleInspector"].value;
			local height = 0.0135;			
			if textTicker.ePosX ~= x1 or textTicker.width ~= w1 or textTicker.posY ~= y1 then
				g_currentMission.hl.setOverlay(g_currentMission.hl.textTicker.mods["VehicleInspector"].overlay["textTicker"], x1, y1, w1);
				g_currentMission.hl.textTicker.mods["VehicleInspector"].value.ePosX = x1;g_currentMission.hl.textTicker.mods["VehicleInspector"].value.width = w1;g_currentMission.hl.textTicker.mods["VehicleInspector"].value.posY = y1;
			end;
		elseif g_currentMission.hl.textTicker.mods["MultiOverlayV4"] == nil and VehicleInspector.global.textTicker.isOn and g_currentMission.hl.textTicker.mods["VehicleInspector"] == nil then
			VehicleInspector.global.textTicker.isOn = false;
			g_currentMission.hl.addTextDisplay( {txt="!! Upps something went wrong (set VehicleInspector Text Ticker Off) !!", txtBold=true, duration=5, warning=true} );
		end;
	end;
end;

function viTextTicker:setOnOff()
	if VehicleInspector.global.textTicker.isOn then
		if g_currentMission.hl.textTicker.mods["MultiOverlayV4"] == nil then
			local value = viTextTicker:getPos(); --aPosX, ePosX, posY, width, height, txtSize, txtHeight
			local isOkay = g_currentMission.hl.generateTextTicker( {modName="VehicleInspector", aPosX=value[1], ePosX=value[2], posY=value[3], width=value[4], height=value[5], txtSize=value[6], txtHeight=value[7]} );
			if not isOkay then	
				VehicleInspector.global.textTicker.isOn = false;
				g_currentMission.hl.addTextDisplay( {txt="!! Upps something went wrong (Generate Text Ticker) !!", txtBold=true, duration=5, warning=true} );
			else
				g_currentMission.hl.textTicker.mods["VehicleInspector"].overlay["textTicker"].visible = false;
			end;
		end;
	else
		if g_currentMission.hl.textTicker.mods["VehicleInspector"] == nil then return;end;
		g_currentMission.hl.textTicker.mods["VehicleInspector"].overlay["textTicker"]:delete();
		g_currentMission.hl.textTicker.mods["VehicleInspector"] = nil;
	end;
end;

function viTextTicker:setTxt(txt, txtColor, repeatable, ignoreMin)
	if not VehicleInspector.global.textTicker.isOn then return;end;
	local firstStart = VehicleInspector.global.textTicker.nextTxtTime[1] == -1 or VehicleInspector.global.textTicker.nextTxtTime[2] == -1;
	local realMin = tonumber(g_currentMission.hl.getRealTime(false, true));
	local realHour = tonumber(g_currentMission.hl.getRealTime(true));
	local nextMin = realMin + VehicleInspector.global.textTicker.nextTxtTime[3];
	local nextHour = realHour;	
	if realHour == 24 then realHour = 0;nextHour = realHour;end;
	if nextMin > 59 then nextHour = nextHour+1;nextMin = nextMin-59;end;	
	if firstStart then
		VehicleInspector.global.textTicker.nextTxtTime[1] = nextHour;
		VehicleInspector.global.textTicker.nextTxtTime[2] = nextMin;
	end;
	if (VehicleInspector.global.textTicker.nextTxtTime[1] == realHour and realMin >= VehicleInspector.global.textTicker.nextTxtTime[2]) or (ignoreMin ~= nil and ignoreMin) or firstStart then	
		VehicleInspector.global.textTicker.nextTxtTime[1] = nextHour;
		VehicleInspector.global.textTicker.nextTxtTime[2] = nextMin;
		if g_currentMission.hl.textTicker.mods["MultiOverlayV4"] ~= nil then			
			g_currentMission.hl.addTextTicker( {modName="MultiOverlayV4", txt=tostring(txt), repeatable=repeatable or 0, txtColor=txtColor or "ls22"} );		
		elseif g_currentMission.hl.textTicker.mods["VehicleInspector"] ~= nil then			
			g_currentMission.hl.addTextTicker( {modName="VehicleInspector", txt=tostring(txt), repeatable=repeatable or 0, txtColor=txtColor or "ls22"} );		
		end;
	end;
end;

function viTextTicker:getTxt(vehicleName, fields)
	local user = g_currentMission.userManager:getUserByUserId(g_currentMission.player.userId)
	local playerName = "";
	if user ~= nil then
		local userName = Utils.getNoNil(user:getNickname(),nil);
		if userName ~= nil then playerName = " ".. tostring(userName).. " ";end;
	end;	
	if string.find(vehicleName:lower(), "fendt") then
		return viTextTicker:fendt(playerName);
	elseif string.find(vehicleName:lower(), "valtra") then
		return viTextTicker:valtra(playerName);
	elseif string.find(vehicleName:lower(), "case") then
		return viTextTicker:case(playerName);
	elseif string.find(vehicleName:lower(), "deutz") then
		return viTextTicker:deutz(playerName);
	elseif string.find(vehicleName:lower(), "claas") then
		return viTextTicker:claas(playerName);
	else
		return viTextTicker:other(playerName);	
	end;
	return nil;
end;

function viTextTicker:other(playerName)
	local language = "_".. string.lower(g_languageShort);
	local txt = {
		_de={"Bulldog Lanz mehr kaputt wie ganz.","War der Bauer ein altes Schwein kam der Trecker aus Neuss am Rhein und war der Bauer etwas reicher fährt er einen Eicher","4 Räder und 2 Eier fertig ist der Steyr.","Steyr das rote wunder rollt den Berg alleine runter.","Hat der Bauer kleine Eier, fährt er einen Steyr.",
		"Wer MF kennt, weiß, dass er die Spreu von Weizen trennt","Vollpension, Kombination, Direktion, Vollfunktion das ist Massey Ferguson","Hat der Bauer keinen Sohn fährt er Massey Ferguson","das L und Massey Ferguson steht dann wohl für Leistung","4 Felgen und einen Schuh Karton fertig ist der Ferguson",
		"Nach der ersten Inspektion klappern alle Bleche schon, das ist typisch..Agrotron","Wer steht auf dem Feld und macht kein Ton? Es ist Nachbars Agrotron","Lieber nen Hänger in der Hose als ein New Holland in der Scheune…","Was haben Wassermelonen und Trecker gemeinsam ? Das rote ist reif und sollst du behalten das grüne sollst du wegschmeißen",
		"Hat der Bauer mal kein Geld, sind die Felgen wieder Gelb","Lieber reiten auf nem Ponny… als fahren auf´em Johnny.","Wer scheiße frisst und Popel kaut fährt auch das, was John Deere baut","Wie verdoppelt man den Wert vom Jonny(Deere)? Einmal voll tanken.","Bist du Ackerdemiker? Ne! Dann mach dich vom Acker!","Der verliert kein Öl der markiert sein Revier",
		"Vorne steht er, hinten dreht er, und ziehen tut er keinen Meter.","Hat der Bauer kalte Ohren, hat er seinen Hut verloren.","Tun dem Bauern sein Füße weh, steht er bis zum Hals in Schnee","Ist die Hand des Bauern kalt, liegt sie abgehackt im Wald","Qualmt das Fahrzeug immer so? Nein, nur wenn der Motor an ist.","Verliert der Bauer seine Hose, war das Gummiband wohl lose.",
		"Kippt man in den Tank den Diesel hüpft der Trecker wie ein Wiesel.","Schlägt der Blitz den Bauern tot, spart sich sein Weib das Abendbrot.","Stirbt der Bauer im Oktober, braucht er im Winter kein Pullover","Stirbt der Bauer Anfang Mai, ist für ihn der Mai vorbei.",
		"Morgens grün abends blau, hoch lebe der Ackerbau.","Rülpst im Stall ganz laut der Knecht, wird sogar den Sauen schlecht","Wenn’s im Stalle dröhnt und rumst die Henne ihren Gockel bumst.","Regnet es im Mai, ist der April vorbei.","Ist der Winter wieder kalt, wird der Bauer schneller alt.","MF das Wunder außen Blech und innen Plunder.","Gott schuf mensch und tier und der Teufel den John Deere !!!",
		"Was ist grün und hüpft am Acker......ein John Deere mit allrad !!!","Jeder fesche Bauernsohn, fährt an Massey Ferguson","Keine Feier ohne Steyr!","Gelbe Felge auf braunem Land, raubt dem Bauern den Verstand.","Und beim melken wurde klar das die Kuh ein Bulle war","Wenn der Fendt am Haken baumelt, MF in die Presse taumelt, wenn Hanomag die Straße teert, ist Eicher fahren lebenswert.",
		"Das Licht geht aus, das Lenkrad zittert, dein Fahrzeug hat den Berg gewittert.","Kotzt der Bauer übern Trecker, war die Brotzeit nicht sehr lecker...","Fällt der Bauer Tod vom Taktor, pflügt er zu nah am Kernreaktor...","Fährt der Bauer raus zum Jauchen, wird er nachts ein Deo brauchen.","Fällt der Bauer in den Dünger, wird er davon auch nicht jünger.",
		"Fällt der Bauer tot vom Traktor, glüht am Waldrand der Reaktor.","Beim Dreschen lass das Rauchen sein, sonst atmest du den Brandrauch ein.","Der Traktor seinen Bauern foppt, wenn er zu spät vorm Dorfteich stoppt.","Fällt der Bauer voll vom Trecker, war der Korn mal wieder lecker.","Kippt der Bauer Milch in'n Tank, wird der Trecker sterbenskrank.",
		"Kommt der Gockel untern Trecker, gibt es morgen keinen Wecker!","Fehlende PS werden durch Wahnsinn ersetzt.","Folgen Sie mir nicht, ich hab mich auch verfahren.","Hier klappert nichts! Das Meiste ist schon abgefallen.","Hier liegt Power auf der Lauer.","Das Leben ist viel zu kurz um kleine Fahrzeuge zu fahren.","Fahre einen Traktor tief und breit, tanke viel und komm' nicht weit.",
		"Mein Traktor ist ein Hybrid. Es verbrennt Benzin und Reifen.","Dieses Fahrzeug verkörpert eine gewisse Portion an GEILHEIT!","Alles, nur nicht langsam!","Fährste quer drifste mehr!","Wenn du einmal schnell fahren willst, schleppe ich dich ab.","Sponsored by Oma, Papa, Sozialamt,...","Behandle deine Fahrzeuge nie wie eine Frau sondern liebe es!",
		"Fahre Immer am Tag, nachts sind die Werkstätten geschlossen!","Das Leben ist zu kurz, um was anderes zu fahren.","Wer bremst verliert, wer blinkt der lügt und wer abbiegt ist feige.","Die DUMMEN haben das Fahrzeug nicht erfunden. Sie FAHREN nur damit.","Fehlendes Tuning wird durch Charme ersetzt.","Am Öl kann's nicht liegen das ich so langsam bin, denn es ist keines drin!",
		"Dieses Fahrzeug steht unter Denkmalschutz!","Für meine Fahrkünste brauch ich keinen Führerschein, ich hab nen Flugschein!","Für viele Bauern ist Traktor fahren wie Sex: Die Bäuerin sitzt teilnahmslos daneben und ruft immer: Nicht so schnell, nicht so schnell.","Es ist billiger, 35 Fahrzeuge und eine Frau zu haben, als 35 Frauen und ein Fahrzeug.",
		"Was nützt ein Tiger im Tank, wenn ein Esel am Steuer sitzt?","Man hört so viel über das richtige Verhalten bei Gewitter, z.B. in einem Traktor könne einem nichts passieren. Meine Freundin hat das geglaubt - jetzt ist sie schwanger.","Trinkt der Bauer morgens Rum, werden alle Furchen krumm.","Die dümmsten Bauern ernten die größten Kartoffeln.","Das Gras wächst nicht schneller, wenn man daran zieht.",
		"Ist der Bauer ständig umnebelt von Dampf, wächst auf seinen Feldern sicher Hanf.","Sorge dich nicht um die Ernte, sondern um die richtige Bestellung deiner Felder.","Pißt der Bauer auf die Felder, spart für Dünger er viel Gelder.","Wenn es auf die Felder nieselt, der Bauer wohl vom Traktor pieselt.","Manche Felder kann man ackern und ackern, und es wächst doch nichts darauf.",
		playerName.. "sorge dich nicht um die Ernte, sondern um die richtige Bestellung deiner Felder.","Suche dir deine Frau nicht beim Tanzen, sondern bei der Erntearbeit im Feld!","Vernachlässige nicht dein eigenes Feld, um das eines anderen zu jäten.","Auch auf dem besten Felde gibt es Unkraut.","Weiden und Bauern muß man alle drei Jahr beschneiden, sonst werden sie zu geil.",
		"Isst der Bauer Stoppelrüben, kommt die Blähung dann in Schüben!","Ackert der Bauer splitternackt, die Magd ein starker Brechreiz packt.","Will der Bauer schneller pflügen, tät ein Porsche schon genügen.","Wenn der Bauer auf dem Misthaufen kräht, kommt der Psychiater meist zu spät.","Ist der Bauer nicht im Feld, sitzt er Zuhause und zählt Geld.",
		"Muht die Kuh laut im Getreide, war ein Loch im Zaun der Weide.","Trinkt der Bauer und fährt Traktor, wird er zum Gefahrenfaktor!","Pflanzt der Bauer Öko-Beete, denkt er kichernd an die Knete!","Läßt der Bauer einen fahren, flieht das Vieh in hellen Scharen.","Bleibt der Schnee zunächst mal liegen, hat der Bauer nichts zu pflügen."
		};
	
	};
	if txt[language] == nil then return nil;end;
	local randomTxt = math.random(1, #txt[language]);
	return txt[language][randomTxt];
end;

function viTextTicker:fendt(playerName)
	local language = "_".. string.lower(g_languageShort);
	local txt = {
		_de={"Wer steht am Feldrand und brennt? Der Fendt.","Ein Bauer der nix kennt, fährt Fendt","Wer Fendt fährt, führt.","Wieso grüßen sich Fendtfahrer nachmittags nicht mehr? .. Weil sie sich schon morgens in der Werkstatt getroffen haben.","Fährt der Bauer Fendt… ist er halt nicht intelligent","Warum darf man mit einem Fendt dieses Jahr nicht auf die Straße? Weil Schaltjahr ist.",
		"Fährt die Bäuerin den Fendt, der Bauer immer rennt.","Wer Fendt in die Werkstatt fährt führt","Wer in lobt und wer ihn kennt braucht einen Trecker namens Fendt","Im Endeffekt ist der Fendt defekt","Wer den Trecker nicht kennt, fährt Fendt","Wer nix kann und wer nix kennt der kauft Stihl und fährt Fendt","Wer Fendt fährt, führt dem Boden schaden zu.",
		"Wer das Geld lieber spart bevor er es verbrennt, kauft sich einen MB track anstatt einen Fendt.","Fendt vergeht, MB track besteht","Warum ein Fendt wenn der Johnny schneller rennt","Wer den John Deere net kennt, fährt Deutz und Fendt","Lieber Gott schütz mich vor Wetter und Wind und alle Trecker die von Fendt sind.",
		"Fährt ein Fendt nicht mehr, muß ein Mechaniker her.","Wer nix gescheites kennt fährt Fendt.","Claas und Fendt sind n Bauern sei End.","Sind die Hühner platt wie Teller war der Fendt mal wieder schneller.","Jeder Bauer mit Verstand setzt seinen Fendt in Brand.","Gibt man beim Fendt Wasser in den Diesel,hüpft der Traktor wie ein Wiesel.",
		"Steht der Hirsch hinterm Berg und Zittert, hat er einen Fendt gewittert.","Lieber mit Fendt der rennt, als mit Eicher als Schleicher.","Wer steht vor dem Berg und flennt ? - Ein Fendt.","Wer ihn liebt, wer ihn kennt, fährt einen Schlepper namens *Fendt*","Weiß der".. playerName.. "keinen Rat, nimmt er seinen Tüddeldraht. Droht der Tüddeldraht zu reißen, fängt er an den Fendt zu schweißen."
		};
	
	};
	if txt[language] == nil then return nil;end;
	if math.random(1, 2) == 1 then return viTextTicker:other(playerName);end;
	local randomTxt = math.random(1, #txt[language]);
	return txt[language][randomTxt];
end;

function viTextTicker:valtra(playerName)
	local language = "_".. string.lower(g_languageShort);
	local txt = {
		_de={"Wenn der MF klemmt, kommt der Valtra, und der rennt","Valtra fahrn ist stets verkehrt, weil Valtra überhaupt nicht fährt.","Valtra fahren das ist Trend, das mach ich bis an mein Lebensend.","Hat sich der MF mal wieder festgewühlt…. Kommt der Valtra und zwar Wassergekühlt..",
		"Fährt der Bauer Valtra liegts wohl an dem hohen Alter.","Valtra, Scheiße fängt mit V an","Nur wer freiwillig zum Altar geht, ist einer der auf Valtra steht.","Wer im Sommer an den Winter denkt, meistens einen Valtra lenkt.","Die Straße brennt, der Asphalt raucht, ein Valtra ist aufgetaucht!"
		};
	
	};
	if txt[language] == nil then return nil;end;
	if math.random(1, 2) == 1 then return viTextTicker:other(playerName);end;
	local randomTxt = math.random(1, #txt[language]);
	return txt[language][randomTxt];
end;

function viTextTicker:claas(playerName)
	local language = "_".. string.lower(g_languageShort);
	local txt = {
		_de={"Fährt der Bauer Claas war in der Tüte zu viel Gras.","Mit Claas machts nu wirklich keinen Spaß","alle 11 Minuten verliert ein Claas sein Lenkrand. Falsch, alle 11 Minuten verliebt sich dein Deutzfahrer in einen Claas","War in der Tüte zu viel Graß, fährt der Bauer einen Claas.",
		"Und wenn der Claas halt nicht mehr Rennt gibt’s nen neuen Trecker namens Fendt!","Ach der".. playerName.. "fährt ein Claas und denkt er wär moderner.","Ein Schlepper von Claas taugt nur zum Schneiden von Gras.","Claas und Fendt sind n Bauern sei End.",
		"Sind die Hühner platt wie Teller war der Claas mal wieder schneller."
		};
	
	};
	if txt[language] == nil then return nil;end;
	if math.random(1, 2) == 1 then return viTextTicker:other(playerName);end;
	local randomTxt = math.random(1, #txt[language]);
	return txt[language][randomTxt];
end;

function viTextTicker:deutz(playerName)
	local language = "_".. string.lower(g_languageShort);
	local txt = {
		_de={"2 Latten über Kreutz fertig ist der Deutz","Hat der Bauer Schmerzen im Kreuz, liegts wohl an der Federung vom Deutz.","Pappkarton mit Ofenrohr fertig ist der Deutzmotor.",playerName.. "ist schlau wie ein Wiesel, er fährt Deutz und spart kaum Diesel","Kolben und ein Ofenrohr, fertig ist der Deutzmotor",playerName.. "freuts, auf dem Hof, da steht EIN Deutz",
		"Hat der Bauer schwule Kinder fährt er Deutz mit 6 Zylinder","3 Dosen und ein Rohr fertig ist der Deutz Motor","Wer den John Deere net kennt, fährt Deutz und Fendt","Sind die Hühner platt wie Teller war der Deutz mal wieder schneller.","Wer Deutz kennt fährt lieber Fendt.","Wieviel Leut braucht`s um einen Deutz zu bedienen - Klar 5! - einen der lenkt und 4 die schieben!",
		"Starkes Herz schwaches Kreuz, das ist der Deutz.","Der".. playerName.. "wieder kräftig flucht, er seinen Deutz im Grünen sucht.","Und selbst im allergrößten Dreck zeigt Deutz die Kraft, die in Ihm steckt","Wenns vorne zischt und hinten kracht, da ein Deutz die Arbeit macht"
		};
	
	};
	if txt[language] == nil then return nil;end;
	if math.random(1, 2) == 1 then return viTextTicker:other(playerName);end;
	local randomTxt = math.random(1, #txt[language]);
	return txt[language][randomTxt];
end;

function viTextTicker:case(playerName)
	local language = "_".. string.lower(g_languageShort);
	local txt = {
		_de={"Viel Gebrüll und wenig Zunder IHC das rote Wunder","Fährt der Case nicht mehr muss halt ein Mechaniker her…","Will der Bauer durch den Schnee, braucht er den starken IHC.","Lieber ein Case mit Arbeitsaufwand als fahren auf nem doofen New Holland","Ob Johnny oder Fendt, bei Schnee hilft nur IHC.","Hat der Bauer nur ein bisschen Verstand, setzt er sein Case in Brand",
		"LIEBER Gott im Himmel…beschütze uns vor Eis und Schnee und den Traktoren vor IHC","Der Motor brennt er hat genug, der IHC vorm Einscharpflug","Wenn der IHC die Wolken schmeißt weis der Fendt was Leistung heißt","Wat rappelt und raucht da unten im Tal? ein Case internationalI","Der Case welch ein glück, hat 4 gänge vorwärts und 8 zurück.",
		"Was kriecht den dort durch Kraut und Rüben ? Es ist ein Case er will nach drüben."
		};
	
	};
	if txt[language] == nil then return nil;end;
	if math.random(1, 2) == 1 then return viTextTicker:other(playerName);end;
	local randomTxt = math.random(1, #txt[language]);
	return txt[language][randomTxt];
end;
